<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Capitulo_3</title>
</head>
<body>
    <h1>Capitulo 4</h1>
    <a>Ejercicio 11</a>

    <script>


        class Node {
            constructor(val) {
                this.data = val;
                this.left = null;
                this.right = null;
                this.aux = 0; 
            }
        }
            
        const elementos = (root) => {
            if (root === null) {
                return 0;
            }
            return elementos(root.left) + elementos(root.right) + 1;
        }

        const insertaraux  = (root) => {
            if (root === null) {
                return null;
            }

            root.aux = elementos(root) - 1;
            root.left = insertaraux(root.left);
            root.right = insertaraux(root.right);
            return root;
        } 

        const aux = (root) => {
            if (root === null) {
                return 0;
            }
            return root.aux + 1;
        }

        const nodoRandom = (root,cont) => {
            if (root === null) {
                return 0;
            }

            if (cont === aux(root.left)) {
                return root.data;
            }

            if (cont < aux(root.left)) {
                return nodoRandom(root.left, cont);
            }
            return nodoRandom(root.right, cont - aux(root.left) - 1);
        }

        const darNodoRandom = (root) => {
            let cont = Math.floor(Math.random() * (root.aux + 1));
            return nodoRandom(root, cont);
        }


        let root;
        root = new Node(8);
        root.left = new Node(2);
        root.right = new Node(6);
        root.left.left = new Node(3);
        root.left.right = new Node(9);
        root.right.left = new Node(5);
        root.right.right= new Node(4);

        insertaraux(root);

        console.log(`Nodo Random del Arbol: ${darNodoRandom(root)}`);
        
    </script>
    
</body>
</html>